#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: writeControl.pan,v 1.1 2004/09/06 14:47:13 cguirao Exp $" 
#
# writeControl.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 5.2
#   date   : Thu Jul 13 15:29:31 METDST 2000
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
#
global par gvar cv bcv actAreaHeight shArea panClassLib 
global geoCmdReply panClassLib panUsrProcs panUsrLib
global argv0 env panWidget panWidgetHlp panDbData cwp ckHeartBeat
global menu menuBar menuHelp ckMenuBar ckActBut ckShHelp ckCCS
# 
#  Get directory root of VLT, integration, current module. 
global VLTROOT INTROOT HOME

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT dummy}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT dummy}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    dummy}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}
set gvar(args) $argv
#
# Link panel to user libraries 
#
set panUsrLib   libastoLib  
set panClassLib {}

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .writeControl 
   set panUsrProcs {writeControlInit writeControlExit writeControlInitData}
   set argc 0 ; set argv {}
} else {
   set par(MY_NAME) [file tail $argv0] 
   set EDITING 0
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

# User's Init Data : called just after panInit
# It contains data to be defined before widgets are created

proc writeControlInitData {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting

#wm positionfrom . user
#wm sizefrom . user
}



# User's Init Procedure : called in panMainStart
# It is executed after the widgets have been created

proc writeControlInit {} {

 # Declare global variables

   global <var>

 # User Initialization
#return
   writeControlInitX
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckHeartBeat   0 ;# Enable Heart-beat
set ckShHelp      0 ;# Set Short Help
set ckActBut      0 ;# Set Action Button Area
set ckMenuBar     0 ;# Setup Menu Bar
set ckCCS         0 ;# Initialize CCS
set ckCmdReply    0 ;# Display Cmd. Reply
set cwp           "" ;# Set Current Working Point
set actAreaHeight 5; # Set height of action area 

panReadOption winter
panCreateFrame writeControl ;# Create empty frame
panGetCvNames  writeControl cv bcv ;# Get Canvas Names
panInit        $argc $argv writeControl ;# Initialization



UifButton          $cv.cancelReqButWdg -canvasAnchor nw  \
                  -command {cancelRequest} -initialState normal  \
                  -label {Cancel Request} -popup 0  \
                  -stateVar gvar(cancelReqBut) -width 15 
UifBarChart        $cv.writeControl-wdg1 -axis 0 -canvasAnchor nw  \
                  -label {Writing Progress} -length 300 -maxVal 100  \
                  -minVal 0 -orient h -ticks 0 -variable gvar(perc) 
UifOutput          $cv.writeControlOutputWdg -anchor w -canvasAnchor nw  \
                  -color Black -font -Adobe-courier-medium-r-normal--14*  \
                  -frame 0  \
                  -labelFont -Adobe-helvetica-medium-r-normal--14*  \
                  -labelWidth 0 -variable gvar(message) -width 40 

#
#  Canvas Items
#


#
# Set Widget Configuration
#
set panWidget(cancelReqButWdg)  {UifButton 120 151 1 0 0 0 0 {} 0 {}}
set panWidget(writeControl-wdg1)  {UifBarChart 23 71 1 0 0 0 0 perc 0 0 0 100 0 0}
set panWidget(writeControlOutputWdg)  {UifOutput 11 23 1 0 0 0 0 message 0 {} {}}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#

#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 382x193
wm title     $panRoot "Write Control"
set par(TITLE) "Write Control" 

panMainStart  writeControl $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc writeControlExit {} {

 # Declare global variables

   global <var>

 # Statements to be executed when exiting
}
