#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# COPYRIGHT (c) 1996 European Southern Observatory
# LICENSE
#
# PROJECT:   VLT Data Flow System
# AUTHOR:    Jeremy Maxfield
# CI NUMBER: 
#
# DESCRIPTION: DFS configuration file for hosts and accounts
# REMARKS:     It must be edit by dfsinstall and table-dfs
#
# $Id: dataflowUser.sh,v 1.9 2005/12/05 09:14:56 cguirao Exp $
#
# Revision history:  see end of file
#
#******************************************************
# ROLEs -MACHINES association
##################
if [ -z "$PipelineWS" ]; then
  export PipelineWS=wu3pl
fi
if [ -z "$OhsWS" ]; then
  export OhsWS=wu3dhs
fi
if [ -z "$OlasWS" ]; then
  export OlasWS=wu3dhs
fi
if [ -z "$QcWS" ]; then
  export QcWS=wu3pl
fi
if [ -z "$UserWS" ]; then
  export UserWS=wgsoff3
fi
if [ -z "$Spare1WS" ]; then
  export Spare1WS=BLANK
fi
if [ -z "$InstrWS" ]; then
  export InstrWS=BLANK
fi
if [ -z "$AstoWS" ]; then
  export AstoWS=wgsarc
fi
export SYBASE_SERVER=ASTOP
export CCS_ENVIRONMENT=wu3dhs
export DFS_VERSION=4_9.i-4
export NGAMS_HOST=134.171.16.121
export NGAMS_PORT=7777
export DFS_OLAS_MGR=par-dataflow@eso.org
##################


#
# if DFS_HOST is defined, it behaves as such host
#
if [ -z "$DFS_HOST" ]; then
  DFS_HOST=`uname -n`
fi

#
# if DFS_USER is defined, it behaves as such account
#
if [ -z "$DFS_USER" ]; then
  export DFS_USER=`whoami`
fi

#
# if DFS_RELEASE is undefined use 'dfs' by default.
#
if [ -z "$DFS_RELEASE" ]; then
  export DFS_RELEASE=dfs
fi


#
# Setup for all users
#
export DFS_ROOT=~flowmgr
export DFS_HOME=${DFS_ROOT}/${DFS_RELEASE}
#export DFS_RUNTIME_ROOT=${DFS_ROOT}/${DFS_RELEASE}
export DFS_HELP=${DFS_HOME}/help
export HOST=${DFS_HOST}
#
# If DFS_PIPELINE_FULL defined this is a pipeline in Paranal/La Silla
# Otherwise is a DFO pipeline (only for dfscheck.sh purposes)
#
export DFS_PIPELINE_FULL=1

#
# If INTROOT is undefined use ${DFS_RELEASE}/INTROOT by default
# If INTROOT is defined, PECS will add it to PATH and MANTPATH
#
if [ -z "$INTROOT" ]; then
  export INTROOT=${DFS_ROOT}/${DFS_RELEASE}/INTROOT
  export PATH=${INTROOT}/bin:${PATH}
  export MANPATH=${INTROOT}/man:${MANPATH}
fi

if [ -z "$SYBASE" ]; then
  unset LANG
  export SYBASE=/opt/sybase
fi

OS=`uname -s`
case $OS in
  SunOS)
   if [ -z "$LD_LIBRARY_PATH" ]; then
     export LD_LIBRARY_PATH=${SYBASE}/lib:${DFS_HOME}/cpl/lib:${JAVA_HOME}/jre/lib/sparc
   else
     export LD_LIBRARY_PATH=${SYBASE}/lib:${DFS_HOME}/cpl/lib:${JAVA_HOME}/jre/lib/sparc:${LD_LIBRARY_PATH}
   fi
   ;;
  Linux)
   if [ -z "$LD_LIBRARY_PATH" ]; then
     export LD_LIBRARY_PATH=${SYBASE}/lib:${DFS_HOME}/cpl/lib:${JAVA_HOME}/jre/lib/i386
   else
     export LD_LIBRARY_PATH=${SYBASE}/lib:${DFS_HOME}/cpl/lib:${JAVA_HOME}/jre/lib/i386:${LD_LIBRARY_PATH}
   fi
   ;;
  HP-UX)
   if [ -z "$SHLIB_PATH" ]; then
     export SHLIB_PATH=${SYBASE}/lib:${DFS_HOME}/cpl/lib:${JAVA_HOME}/jre/lib/PA_RISC
   else
     export SHLIB_PATH=${SYBASE}/lib:${DFS_HOME}/cpl/lib:${JAVA_HOME}/jre/lib/PA_RISC:${SHLIB_PATH}
   fi
   ;;
esac

#
# Make sure that DHS_HOST and DHS_CONFIG is not defined
#
unset DHS_HOST
unset DHS_CONFIG
   
   
if [ -z "$VLTROOT" ]; then 
  export VLTROOT=/vlt/APR2004/NOCCS
fi

export PATH=${DFS_HOME}/bin:${DFS_HOME}/cpl/bin:${PATH}
export MANPATH=${DFS_HOME}/man:${MANPATH}

if [ ${DFS_HOST} = $PipelineWS ]; then
  export MIDASHOME=/midas
  export MIDVERS=05SEP
  export MID_WORK=~/midwork
  export PATH=${MIDASHOME}/${MIDVERS}/system/unix:/opt/msql2/bin:${PATH}
  export PIPE_HOME=/home/quality/pipelines
  export CPLDIR=${DFS_HOME}/cpl
  export DFS_GASGANO_CONFIG_DIR=/home/quality/gasgano/config

  #
  # if DFS_ACCOUNT_ROLE is defined, dataflowUser.sh behaves as such account
  #
  if [ -n "$DFS_ACCOUNT_ROLE" ]; then
     export DFS_USER=$DFS_ACCOUNT_ROLE
  fi

  #
  # To have a chance to change the DFS data location
  #
  if [ -z "$DFS_DATA_ROOT" ]; then
      export DFS_DATA_ROOT=/data
  fi
 
  case ${DFS_USER} in
  quality) 
    export DFS_QC1_LOG_DIR=${DFS_DATA_ROOT}/msg
    export DFS_QC1_DIC_DIR=~/qc1/Dictionary
    export DFC_DB_ROOT=$DFS_DATA_ROOT
    export DFC_DB_SERVER=$PipelineWS
    export INS_ROOT=~quality/INS_ROOT
    export INS_ROOT_DO=~quality/INS_ROOT_DO
    ;;

  pipeline) 
    export DFS_DHS_THREADS=1
    export OLAS_ID=PRO
    export DFC_DB_ROOT=${DFS_DATA_ROOT}
    export DFC_DB_SERVER=$PipelineWS
    export DFS_REDBLOCK=${DFS_DATA_ROOT}/redblock
    export DFS_PRODUCT=${DFS_DATA_ROOT}/reduced
    export DFS_DATA_REDUCED=$DFS_PRODUCT
    export DFS_LOG=${DFS_DATA_ROOT}/msg
    export INS_ROOT=~quality/INS_ROOT
    export INS_ROOT_DO=~quality/INS_ROOT_DO
    export DSQUERY=$SYBASE_SERVER
    export DHS_DATA=${DFS_DATA_ROOT}/raw
    export DFS_PIPE_ALLPRODUCTS=NO
    export DFS_DATA_RAW=${DFS_DATA_ROOT}/raw
    export DFS_QC_RAW=${DFS_DATA_ROOT}/lists/raw_qcm
    export DFS_DO_RAW=${DFS_DATA_ROOT}/lists/raw_do
    export DFS_DATA_RAW_DO=${DFS_DO_RAW}
    export DFS_DATA_RAW_QCM=${DFS_QC_RAW}
    export DFS_DATA_MSG=${DFS_DATA_ROOT}/msg
    export DFS_QC_LOG=${DFS_DATA_ROOT}/msg
    export DHS_HOST=$OlasWS
    export DHS_CONFIG=archeso@${OlasWS}:/data/msg
    export BAD_DIR=${DFS_DATA_ROOT}/bad
    export DHS_LOG=${DFS_LOG}
    export DFS_DATA_REDUCED_OLAS=${DFS_DATA_ROOT}/lists/reduced_olas
    export DFS_QC_TESTING=0
    export DFS_QC1_LOG_DIR=$DFS_LOG
    export DFS_QC1_DIC_DIR=~quality/qc1/Dictionary
    export DFS_DATA_BACKLOG=${DFS_DATA_ROOT}/backlog
    export DFS_NGAMS_HOST=$NGAMS_HOST
    export DFS_NGAMS_PORT=$NGAMS_PORT
    if [ -d ${MIDASHOME}/${MIDVERS}/pipeline/isaac ]; then
      export DFS_ISAAC_REC=${MIDASHOME}/${MIDVERS}/pipeline/isaac
      export DFS_ISAAC_ECLIPSE=${DFS_ISAAC_REC}/eclipse/bin
      export PATH=${DFS_ISAAC_ECLIPSE}:${PATH}
    fi
    if [ -d ${MIDASHOME}/${MIDVERS}/pipeline/naco ]; then
      export DFS_NACO_REC=${MIDASHOME}/${MIDVERS}/pipeline/naco
      export DFS_NACO_ECLIPSE=${DFS_NACO_REC}/eclipse/bin
      export PATH=${DFS_NACO_ECLIPSE}:${PATH}
    fi
    if [ -f ~/.eclipse-rc ]; then
      . ~/.eclipse-rc
    fi
    if [ -d /opsw/util/python ]; then
      export PATH=/opsw/util/python/bin:$PATH
    fi
    if [ -d /opsw/packages ]; then
      export PYTHONPATH=/opsw/packages
    fi
    ;;
  esac
fi

if [ ${DFS_HOST} =  $OlasWS  ]; then 
  case ${DFS_USER} in
  archeso) 
    export DFS_DHS_THREADS=1
    #
    # If there is a /data_secondary directory (or a link to a directory)
    # sets the DHS variables to default values.
    # See man page for dhs (command: 'man dhs') for details
    #
    if [ -d /data_secondary ] ; then
      export DHS_SECONDARY_DATA=/data_secondary
      export DHS_CRITICAL_DISK_SPACE=500
      export DHS_OPERATIONAL_DISK_SPACE=12000
      export DHS_IDLE_TIME_START=15:00
      export DHS_IDLE_TIME_STOP=22:00
    fi
    export DHS_DATA=/data/raw
    export DHS_LOG=/data/msg
    export BAD_DIR=/data/bad
    export DHS_HOST=$OlasWS
    export DHS_CONFIG=archeso@${DHS_HOST}:/data/msg
    export INS_ROOT=${DFS_ROOT}/${DFS_RELEASE}/data
    export DSQUERY=$SYBASE_SERVER
    export DFS_DATA_RAW=/data/raw
    export DFS_DATA_MSG=/data/msg
    export DFS_DATA_BACKLOG=/data/backlog
    export DFS_NGAMS_HOST=$NGAMS_HOST
    export DFS_NGAMS_PORT=$NGAMS_PORT
    export DFS_NGAMS_DATA=/data/ngams-raw
    ;;
  esac
fi	

if [ ${DFS_HOST} =  $UserWS  ]; then 
  case ${DFS_USER} in
  astro) 
    if [ -z "$DFS_DATA_ROOT" ]; then
        export DFS_DATA_ROOT=/data
    fi
    export DHS_HOST=$OlasWS
    export DHS_CONFIG=archeso@${DHS_HOST}:/data/msg
    export DHS_DATA=${DFS_DATA_ROOT}/raw
    export DHS_LOG=${DFS_DATA_ROOT}/msg
    export BAD_DIR=${DFS_DATA_ROOT}/bad
    export DFS_DATA_RAW=${DFS_DATA_ROOT}/raw
    export DFS_DATA_REDUCED=${DFS_DATA_ROOT}/reduced
    export DFS_DATA_MSG=${DFS_DATA_ROOT}/msg
    export DFS_DATA_BACKLOG=${DFS_DATA_ROOT}/backlog
    export DFS_GUI_CONFIG=${INTROOT}/config
    export INS_ROOT=${DFS_ROOT}/${DFS_RELEASE}/data
    export DSQUERY=$SYBASE_SERVER
    ;;
  esac
fi

if [ ${DFS_HOST} =  $AstoWS  ]; then 
  case ${DFS_USER} in
  archeso) 
    if [ -z "$DFS_DATA_ROOT" ]; then
        export DFS_DATA_ROOT=/data
    fi
    export OlasWS=BLANK
    export DHS_DATA=${DFS_DATA_ROOT}/raw
    export DHS_LOG=${DFS_DATA_ROOT}/msg
    export BAD_DIR=${DFS_DATA_ROOT}/bad
    export DHS_HOST=$OlasWS
    export DHS_CONFIG=archeso@${DHS_HOST}:/data/msg
    export ASTO_HOST=$AstoWS
    export ASTO_STAGE_ROOT=/media/stage
    export ASTO_CONFIG_DIR=~archeso/astoconf
    export ASTO_REQ_DIR=/media/romanic
    export DEFAULT_CONFIG_DIR=~archeso/astoconf
    export DFS_DATA_RAW=${DFS_DATA_ROOT}/raw
    export DFS_DATA_REDUCED=${DFS_DATA_ROOT}/reduced
    export DFS_DATA_MSG=${DFS_DATA_ROOT}/msg
    export DFS_BACKLOG=${DFS_DATA_ROOT}/backlog
    export DSQUERY=$SYBASE_SERVER
    export GEAR_WRITERS=1
    export INS_ROOT=${DFS_ROOT}/${DFS_RELEASE}/data
    export PATH=${SYBASE}/bin:/opt/cdrecord/bin:${PATH}
    export DFS_DATA_BACKLOG=${DFS_DATA_ROOT}/backlog
    ;;
  esac
fi

# 
# Here we source the stuff for Java applications
#
#
# Java Development environment
#
export PATH=${JAVA_HOME}/bin:${PATH}
#
# DFS Java binaries
#
export PATH=${PATH}:${DFS_HOME}/dataflowJava/bin
#

unset CCS_ENVIRONMENT
unset SYBASE_SERVER
