#!/bin/bash 
#
# vcsolac.sh: starts/stops the vcsolac process
#
# chkconfig: 2345 93 07
#
# description: Starts and stops the vcsolac as a  daemons
#
# processname: vcsolac
#

OWNER=XXXXXX

#
# Check the OWNER user exist 
#
id $OWNER > /dev/null
if [ $? -ne 0 ]; then  
  exit 1
fi

# Source function library.
. /etc/rc.d/init.d/functions 


RETVAL=0

start() {
        echo -n $"Starting DFS vcsolac: "
	daemon --user $OWNER start-vcsolac
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch /var/lock/subsys/vcsolac
        return $RETVAL
}

stop() {
        echo -n $"Shutting down DFS vcsolac: "
	daemon --user $OWNER cleanup-vcsolac
        RETVAL=$?
        echo
	[ $RETVAL -eq 0 ] && rm -f /var/lock/subsys/vcsolac
        return $RETVAL
}


# See how we were called.
case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  status)
	status vcsolac
	;;
  restart)
	stop
	start
	;;
  *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
esac

exit $RETVAL
