package org.eso.ohs.core.gui.widgets;

import java.awt.Component;

import javax.swing.JFrame;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import org.eso.ohs.core.gui.models.NaturalNumModel;

/**
 * Excepts the user id and password and returns a flag to
 * the caller to determinew what action has taken place.
 * <p>
 * $Id: LoginDialog.java,v 1.2 2004/08/27 09:41:58 ddorigo Exp $
 * <br>
 * @author Tim Canavan
 * <br>ChangeLog: Bob Kemp
 */

public class LoginDialog extends SimpleInputDialog {

    /**   
     * User name entry field
     */
    private JTextField usernameField_ = new JTextField(10);

    /** 
     * Password entry field
     */
    private JPasswordField passwordField_ = new JPasswordField(10);

    /**
     * Create a password dialog
     * @param frm Frame for dialog
     * @param title title of dialog
     */
    public LoginDialog(JFrame frm, String title) {
	this(frm, title, null);
    }
    
    /**
     * Create a password dialog
     * @param frm Frame for dialog
     * @param title title of dialog
     */
    public LoginDialog(JFrame frm, String title,String message,  Component extraComponent) {
        super(frm, title);
        initialise(message,
    		    new String[] { "User name ", "Password " },
    		    new Component[] { usernameField_, passwordField_,extraComponent }
        );

    	usernameField_.setDocument(new NaturalNumModel());
    	passwordField_.setEchoChar('-');	
    }

    /**
     * Create a password dialog
     * @param frm Frame for dialog
     * @param title title of dialog
     */
    public LoginDialog(JFrame frm, String title, String message) {
	super(frm, title);

	initialise(message,
		    new String[] { "User name ", "Password " },
		    new Component[] { usernameField_, passwordField_ }
	);

	usernameField_.setDocument(new NaturalNumModel());
	passwordField_.setEchoChar('-');	
    }

    protected void requestInitialFocus() {
	usernameField_.requestFocus();
    }

    /**
     * Get the username which is always an integer
     */
    public int getUserName() {
	String userNameStr = usernameField_.getText();

	try {
	    return new Integer(userNameStr).intValue();
	}
	catch(NumberFormatException e) {            
	    return -1;
	}
    }

    /**
     * Get the password the usser has entered
     */
    public String getPassword() {
	return new String(passwordField_.getPassword());
    }

}
