package org.eso.ohs.core.gui.widgets.examples;

import java.awt.BorderLayout;
import java.awt.Font;

import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import org.eso.ohs.core.gui.widgets.OHSButtonGroup;
import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;

/**
 * Second page of the example wizard.
 * 
 * @version $Revision: 1.2 $
 * @author amchavan, Jul 27, 2005
 */

// $Id: InstallerPage2.java,v 1.2 2005/09/01 13:00:59 ddorigo Exp $

public class InstallerPage2 extends OHSWizardPage {

    ButtonGroup buttongroup1 = new OHSButtonGroup( "accept" );
    JRadioButton jradiobutton1 = new JRadioButton();
    JRadioButton jradiobutton2 = new JRadioButton();
    JTextArea jtextarea1 = new JTextArea();

    /**
     * Default constructor
     */
    public InstallerPage2( OHSWizard wizard ) {
        super( wizard );
        setLayout( new BorderLayout() );
        add( createPanel(), BorderLayout.CENTER );
        listenTo( jradiobutton1 );
        listenTo( jradiobutton2 );
    }

    public JPanel createPanel() {

        Box box = Box.createVerticalBox();
        JPanel jpanel1 = new JPanel();

        JLabel jlabel1 = new JLabel();
        jlabel1.setFont( new Font( "Tahoma", Font.BOLD | Font.ITALIC, 14 ) );
        jlabel1.setText( "Step 2: licence agreement" );
        box.add( jlabel1 );

        jtextarea1.setLineWrap( true );
        jtextarea1.setText( "blah blah blah this is a licence agreement...skjhaskdjha sdkj hasdkja lkJAS lksdjha lsdkja hl" );
        JScrollPane jscrollpane1 = new JScrollPane();
        jscrollpane1.setViewportView( jtextarea1 );
        jscrollpane1.setVerticalScrollBarPolicy( JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED );
        jscrollpane1.setHorizontalScrollBarPolicy( JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED );
        box.add( jscrollpane1 );

        Box box2 = Box.createHorizontalBox();

        jradiobutton1.setActionCommand( "Accept" );
        jradiobutton1.setText( "Accept" );
        buttongroup1.add( jradiobutton1 );
        box2.add( jradiobutton1 );

        jradiobutton2.setActionCommand( "NoAccept" );
        jradiobutton2.setText( "Don't accept" );
        buttongroup1.add( jradiobutton2 );
        box2.add( jradiobutton2 );

        box.add( box2 );
        box.add( Box.createVerticalStrut( 10 ));
        jpanel1.add( box );
        return jpanel1;
    }

    /** @return <code>true</code> if one of the radio buttons was selected */
    protected boolean isReady() {
        return (buttongroup1.getSelection() != null);
    }

}
