package org.eso.ohs.core.utilities;

// $Id: SqlUtils.java,v 1.1 2004/02/17 14:31:55 tcanavan Exp $

/**
 * This class exports some general purpose functionalities to process
 * database data 
 * <br>
 * @author Carlo Boarotto, ESO 20-Jul-1999 
 */
public class SqlUtils {
    
    /**
     * Returns a string in the correct format for an SQL literal string,
     * with any dangerous characters escaped, eg &quot;
     * 
     * @param str   the string literal to be escaped/
     * @return	    a valid SQL string representing <code>str</code>
     */
    public static String sqlEscapedString(String str) {

	if (str == null) {
	    return "''";
	}

	StringBuffer sb = new StringBuffer();
	final int length = str.length();

	sb.append('\'');

	for (int j=0; j < length; j++) {
	    char ch = str.charAt(j);
	    if (ch == '\'') {
		sb.append("'");
	    }
	    sb.append(ch);
	}

	sb.append('\'');

	return sb.toString();
    }


}
