package org.eso.ohs.core.utilities;

import java.util.EventListener;

/**
 * Listener interface for changes to the system state.
 *
 * <p>
 * $Id: SystemStatusListener.java,v 1.1 2004/02/17 14:31:55 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */

public interface SystemStatusListener extends EventListener {

    /**
     * Listener method for changes in the system status.
     * This is used to alert components to
     * <ul>
     * <li> a system shutdown,
     * <li> the operator logging in as a new user, or
     * <li> the need for gui data structures to be synchronized
     *      with their associated business objects.
     * </ul>
     *
     * @param	ev	event giving information about the status change
     */
    public void systemStatusChange(SystemStatusEvent ev);

}

