/*
 * Created on 30.06.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.eso.ohs.dfs;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.eso.ohs.core.docview.datatrans.AdaptorFactory;
import org.eso.ohs.core.docview.datatrans.ObjectAdaptor;
import org.eso.ohs.instruments.Instrument;
import org.eso.ohs.instruments.InstrumentConstraintConfig;
import org.eso.ohs.instruments.InstrumentConstraintMetaData;
import org.eso.ohs.instruments.InstrumentList;

/**
 * This class is a helper class that deals with assiging values
 * to Constraint Set from the constraint config files
 * @author tcanavan
 *
 */
public class ConstraintProperties {

    public static void setConstraintDefaults(ObservationBlock ob)
        throws
            NoSuchMethodException,
            IllegalAccessException,
            InvocationTargetException {
        ConstraintSet cs = ob.getConstraintSet();
        float version = ob.getOd().getIPVersion();
        String instCode = ob.getOd().getInstrument();
        Instrument instrument =
            InstrumentList.getInstance().getInstrument(instCode, version);
        InstrumentConstraintConfig[] insConfList = instrument.getCsConfList();
        for (int i = 0; i < insConfList.length; i++) {
            InstrumentConstraintMetaData metaData =
                insConfList[i].getMetaData();
            // Create a setter method from the attribute name.
            String propName = insConfList[i].getName();
            ObjectAdaptor oa = AdaptorFactory.getAdaptor(cs, propName);
            oa.setValue(metaData.getDefaultValue());
            Class cls = cs.getClass();
            Method get;
            get = cls.getMethod("get" + insConfList[i].getName(), new Class[] {
            });
            Method set =
                cls.getMethod(
                    "set" + insConfList[i].getName(),
                    new Class[] { get.getReturnType()});
            if (metaData.getDefaultValue() != null
                && metaData.getDefaultValue().length() > 0)
                set.invoke(cs, new Object[] { oa.getRawValue()});
        }
    }

    public static void refreshConstraintSets(
        ObservationBlock ob,
        float ipVersion)
        throws
            NoSuchMethodException,
            IllegalAccessException,
            InvocationTargetException {
        ConstraintSet cs = ob.getConstraintSet();
        float version = ipVersion;
        String instCode = ob.getOd().getInstrument();
        Instrument instrument =
            InstrumentList.getInstance().getInstrument(instCode, version);
        InstrumentConstraintConfig[] insConfList = instrument.getCsConfList();
        for (int i = 0; i < insConfList.length; i++) {
            InstrumentConstraintMetaData metaData =
                insConfList[i].getMetaData();
            // Create a setter method from the attribute name.
            String propName = insConfList[i].getName();
            ObjectAdaptor oa = AdaptorFactory.getAdaptor(cs, propName);

            Class cls = cs.getClass();
            Method get;
            get = cls.getMethod("get" + insConfList[i].getName(), new Class[] {
            });
            Object obje = get.invoke(cs, new Object[] {
            });           
            Method set =
                cls.getMethod(
                    "set" + insConfList[i].getName(),
                    new Class[] { get.getReturnType()});
            if (metaData.getDefaultValue() != null
                && metaData.getDefaultValue().length() > 0) {
                if (obje == null || !insConfList[i]
                    .getMetaData()
                    .verify(
                        obje.toString(),
                        insConfList[i].getMetaData().getBaseType())) {
                    oa.setValue(metaData.getDefaultValue());
                    set.invoke(cs, new Object[] {oa.getRawValue()});
                }
            }
        }
    }

}
