/* $Id: OpcReferee.java,v 1.21 2005/03/30 09:56:11 tcanavan Exp $ */

package org.eso.ohs.dfs;

import org.apache.log4j.Logger;

/**
 * Opc Referee business object class.
 * <br>
 * 
 * @see org.eso.ohs.persistence.dbase.phase1.DbaseHandlerOpcReferee
 * @author Carlo Boarotto, 10-Mar-2000
 */
public class OpcReferee extends BusinessObject {

	private static Logger stdlog_ = Logger.getLogger(OpcReferee.class);

	/** Version id for object serialization. */
	static final long serialVersionUID = -7526074509242805287L;

	/** Proposal panel (or category). */
	private String panel_;

	/** Proposal panel (or category). */
	private EsoUser user;

	/** OPC subpanel (panel splitting just for grading) */
	private int opcSubpanel_;

	/** cycle_label. */
	private String cycleLabel_ = "";

	/** cycle id  */
	private int cycleId_;

	/** user id from eso_users */
	private long userId_;

	/** Email address. */
	private String email_ = "";

	/** Referee's acronym. */
	private String refereeAcronym_ = "";

	/** Is chairman boolean flag. */
	private boolean chair_;

	/** Is opc member boolean flag. */
	private boolean opcMember_;

	//----------------------------------------
	// Constructor
	//----------------------------------------

	/**
	 * Create an OpcReferee object
	 */
	public OpcReferee() {
		super();
	}

	//----------------------------------------
	// Public Methods
	//----------------------------------------

	/**
	 * Get value for panel_ property
	 *
	 * @return the current value of the property
	 */
	public String getPanel() {
		return panel_;
	}

	/**
	 * Set new value for panel_ property
	 *
	 * @param newValue the new value for the property
	 */
	public void setPanel(String newValue) {
		panel_ = newValue;
		firePropertyChangeEvent();
	}

	/**
	 * Get the user associated with the referee
	 *
	 * @return the current value of the property
	 */
	public EsoUser getUser() {
		return user;
	}

	/**
	 * Get value for opcSubpanel_ property
	 *
	 * @return the current value of the property
	 */
	public int getOpcSubpanel() {
		return opcSubpanel_;
	}

	/**
	 * Set new value for opcSubpanel_ property
	 *
	 * @param newValue the new value for the property
	 */
	public void setOpcSubpanel(int newValue) {
		opcSubpanel_ = newValue;
		firePropertyChangeEvent();
	}
	/**
	  * Get value for cycleId_ property
	  *
	  * @return the current value of the property
	  */
	public String getCycleLabel() {

		return cycleLabel_;
	}

	/**
	 * Set new value for cycleId_ property
	 *
	 * @param newValue the new value for the property
	 */
	public void setCycleLabel(String newValue) {
		cycleLabel_ = newValue;
	}
	/**
	 * Get value for opcSubpanel_ property
	 *
	 * @return the current value of the property
	 */
	public int getCycleId() {
		return cycleId_;
	}

	/**
	 * Set new value for opcSubpanel_ property
	 *
	 * @param newValue the new value for the property
	 */
	public void setCycleId(int newValue) {
		cycleId_ = newValue;
		firePropertyChangeEvent();
	}

	/**
	 * Get value for opcSubpanel_ property
	 *
	 * @return the current value of the property
	 */
	public long getUserId() {
		return userId_;
	}

	/**
	 * Set new value for property
	 *
	 * @param newValue the new value for the property
	 */
	public void setUserId(long newValue) {
		userId_ = newValue;
		firePropertyChangeEvent();
	}

	/**
	 * Get value for email_ property
	 *
	 * @return the current value of the property
	 */
	public String getEmail() {
		return email_;
	}

	/**
	 * Set new value for email_ property
	 *
	 * @param newValue the new value for the property
	 */
	public void setEmail(String newValue) {
		email_ = newValue;
		firePropertyChangeEvent();
	}

	/**
	 * Get value for refereeAcronym_ property
	 *
	 * @return the current value of the property
	 */
	public String getRefereeAcronym() {
		return refereeAcronym_;
	}

	/**
	 * Set new value for refereeAcronym_ property
	 *
	 * @param newValue the new value for the property
	 */
	public void setRefereeAcronym(String newValue) {
		refereeAcronym_ = newValue;
		firePropertyChangeEvent();
	}

	/**
	 * Get value for chair_ property
	 *
	 * @return the current value of the property
	 */
	public boolean getChair() {
		return chair_;
	}

	/**
	 * Set new value for chair_ property
	 *
	 * @param newValue the new value for the property
	 */
	public void setChair(boolean newValue) {
		chair_ = newValue;
		firePropertyChangeEvent();
	}

	/**
	 * Get value for chair_ property
	 *
	 * @return the current value of the property
	 */
	public boolean getOpcMember() {
		return opcMember_;
	}

	/**
	 * Set new value for opcMember_ property
	 *
	 * @param newValue the new value for the property
	 */
	public void setOpcMember(boolean newValue) {
		opcMember_ = newValue;
		firePropertyChangeEvent();
	}

	public Object accept(BusinessVisitor v, Object arg) {
		return null;
	}
	/**
	 * @see org.eso.ohs.dfs.StorableObject#postProecess()
	 */
	public void postProecess() {
	}

	
	public String getAcronymPanel() {
			StringBuffer acronymPanel = new StringBuffer();
			acronymPanel
				.append(getRefereeAcronym())
				.append("(")
				.append(getPanel())
				.append(getOpcSubpanel())
				.append(")");
			return acronymPanel.toString();
		}
	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object obj) {

			if (obj instanceof OpcReferee) {
				OpcReferee bo = (OpcReferee)obj;
			 return bo.getRefereeAcronym().compareTo(getRefereeAcronym());
		}
			return 0;
		}

    /**
     * @param user The user to set.
     */
    public void setUser(EsoUser user) {
        this.user = user;
    }
   }
