/*
 * Created on Feb 26, 2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.eso.ohs.dfs;

import java.io.File;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.eso.ohs.core.utilities.TextUtils;

/**
 * @author ddorigo
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ProposalFile  {

	private String fileName_;
	private Vector tempFileList_;

	private File file_ = null;

	private ObsProgramme proposal_ =null;

	private String format_ = "";
	
	public static final String FORMAT_PDF = "pdf";
	public static final String FORMAT_PS = "ps";
	/**
		 * Field stdlog_
		 */
	protected static Logger stdlog_ =
		Logger.getLogger(ProposalFile.class);
	/**
	 * @param file
	 * @param proposalId
	 */
	public ProposalFile(String fileName, ObsProgramme proposal, String format) {
		setFileName(fileName);
		File propFile = new File(fileName+"."+format);
		setFile(propFile);
		setProposal(proposal);
		setFormat(format);
		tempFileList_ = new Vector();
		addTempFile(propFile);
	}

	public ProposalFile(File file, ObsProgramme proposal) {
		setFileName(file.getName());
		setFile(file);
		setProposal(proposal);
		tempFileList_ = new Vector();
		addTempFile(file);
		String fileName = file.getName();
		String[] fileNameSplitteed = TextUtils.stringToStringArray(fileName, ".", false);
		if (fileNameSplitteed.length> 1) {
			setFormat(fileNameSplitteed[fileNameSplitteed.length-1]);
		} else {
			setFormat("");
		}
	}

	public void addTempFile(File tempFile) {
		tempFileList_.addElement(tempFile);
	}
	
	public void deleteTempFiles() {
		for ( int i = 0 ; i < tempFileList_.size(); i++) {
			File tempFile = (File) tempFileList_.elementAt(i);
			stdlog_.debug("deleting File "+tempFile.getAbsolutePath());
			tempFile.deleteOnExit();
		
		}
	}
	
	public void setFile(File file_) {
		this.file_ = file_;
	}

	public File getFile() {
		return file_;
	}

	public void setProposal(ObsProgramme proposal) {
		proposal_ = proposal;
	}

	public ObsProgramme getProposal() {
		return proposal_;
	}

	public void setFormat(String format) {
		this.format_ = format;
	}

	public String getFormat() {
		return format_;
	}

	public boolean equals(Object obj) {
	  if (obj instanceof ProposalFile) {
		  ProposalFile bo = (ProposalFile)obj;
		  return bo.getProposal().getTableId() == getProposal().getTableId();
	  } 
	  return false;
	  }

	private void setFileName(String fileName_) {
		this.fileName_ = fileName_;
	}

	public String getFileNameNoExtension() {
		return fileName_;
	}


}
