package org.eso.ohs.instruments;

/** 
 * This class is defines an interface for creating InstrumentList objects.
 * An instance of this class needs to be set to the InstrumentList in order
 * declare it as the factory for InstrumentList objects. This is done with 
 * the call:
 *
 *    
 *    InstrumentList.setInstrumentListFactory(new MyFactory(...));
 * 
 * @author Nick Kornweibel for ESO.
 */
 
public interface InstrumentListFactory {
    /**
     * @return an InstrumentList object.
     */
    public InstrumentList getInstrumentList();
}