/*
 * @(#)PilListener.java     $Revision: 1.4 $  $Date: 2005/11/16 16:19:27 $
 *
 * Copyright (C) 2000 European Southern Observatory 
 * License:  GNU General Public License version 2 or later
 */
package org.eso.ohs.persistence;

import java.util.EventListener;


/** A listener that is notified when a OBEvent is arrived
 * 
 *  @version $Id: OBListener.java,v 1.4 2005/11/16 16:19:27 ddorigo Exp $
 *  @author  G.Passera, DMD/ESO, <gpassera@eso.org>
 */
public interface OBListener extends EventListener {

    /**
     * the delete event
     */
    public final String DELETE_EVENT = "Delete";

    /** Called whenever a new file has arrived
     *
     *  @param e   Event that characterizes the arrive 
     */
    public void obPropertyChange(OBEvent e);

  
}

