package org.eso.ohs.persistence.account.service;

import java.util.Collection;

import org.eso.ohs.dfs.account.Account;
import org.eso.ohs.dfs.account.AccountProfile;
import org.eso.ohs.persistence.account.dao.AccountDAO;
import org.eso.ohs.persistence.account.dao.AccountDAOHibernate;
import org.springframework.dao.DataAccessException;

public class AccountServiceImpl implements AccountService {
	
	
	private AccountDAO accountDAO;
	
	public AccountServiceImpl() {
		accountDAO = new AccountDAOHibernate();
	}

	public Account getAccount(Integer id) throws DataAccessException {
		return accountDAO.getAccount(id);
	}

	public Account getAccount(String userName) throws DataAccessException {
		return accountDAO.getAccount(userName);		
	}

	public Account getUserAndProfiles(String userName)
			throws DataAccessException {
		return accountDAO.getUserAndProfiles(userName);
	}

	public AccountProfile getDefaultProfile(String userName)
			throws DataAccessException {
		return accountDAO.getDefaultProfile(userName);		
		
	}

	public void updateProfile(AccountProfile accProfile)
			throws DataAccessException {
		accountDAO.updateProfile(accProfile);				
	}

	public void create(Account account) throws DataAccessException {
		accountDAO.create(account);
	}

	public void updateAccount(Account account) throws DataAccessException {
		accountDAO.updateAccount(account);
	}

	public void changePassword(Account account) throws DataAccessException {
		accountDAO.changePassword(account);
	}

	public void delete(Account account) throws DataAccessException {
		accountDAO.delete(account);
	}

	public boolean accountExists(String userName) throws DataAccessException {
		return accountDAO.accountExists(userName);
	}

	public AccountProfile getDefaultProfile(Account account)
			throws DataAccessException {
		return accountDAO.getDefaultProfile(account);
	}

	public Account getAccountRoles(String userName) throws DataAccessException {
		return accountDAO.getAccountRoles(userName);
	}

	public AccountDAO getAccountDAO() {
		return accountDAO;
	}

	public void setAccountDAO(AccountDAO accountDAO) {
		this.accountDAO = accountDAO;
	}

}
