package org.eso.ohs.phase2.actions;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.utilities.MsgManager;
import org.eso.ohs.phase2.visiplot.AreaColorEditor;
import org.eso.ohs.phase2.visiplot.ChartColorItem;


/**
 * Open the JColorChooser
 * <p>
 * $Id: AreaColorEditorAction.java,v 1.1 2005/11/29 16:23:29 gdonino Exp $
 * 
 * @version $Revision $
 * @author Gabriele Donino
 */
public class AreaColorEditorAction extends ActionSuperclass {
	JFrame parentFrame_ = null;
	String title_ = null;
	ChartColorItem item_ = null;;

	/**
	 * 
	 * @param component The component the action is associated to.
	 * @param parentFrame parent frame.
	 * @param title title
	 */
	public AreaColorEditorAction(ChartColorItem item, JFrame parentFrame, String title) {
		super(parentFrame, title);
		
		/* check for the precondition */
		if (parentFrame == null) MsgManager.errPrecondition("The parentFrame attribute is null");
		if (title == null) MsgManager.errPrecondition("The title attribute is null");
		/* DbC */
	
		parentFrame_ = parentFrame;
		title_ = title;	
		item_ = item;
	}
	
	private void createAndShowGUI(JFrame frame, String title) {
		assert(frame != null): MsgManager.errPrecondition("The frame is null");
		JFrame.setDefaultLookAndFeelDecorated(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		ChartColorItem tmpItem = (ChartColorItem) item_.clone();
		
		AreaColorEditor dialog = new AreaColorEditor(tmpItem, frame, true,title);
		
		dialog.pack();
		dialog.setVisible(true);
		if (dialog.getUserChoice() == JOptionPane.OK_OPTION) {
		//	Border border = BorderUIResource.getRaisedBevelBorderUIResource(); 
			//component_.setBorder(border);
			item_.setAreaColor(tmpItem.getAreaColor());
		}
	}

	/**
	 * action starting method
	 * 
	 * @param ev
	 *            user-initiated ActionEvent
	 */
	public void actionPerformedImpl(ActionEvent ev) {
		createAndShowGUI(parentFrame_, title_);
		
	}
}