package org.eso.ohs.phase2.apps.masktracker;

import java.awt.Component;

import org.apache.log4j.Logger;
import org.eso.ohs.persistence.AppConfig;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.phase2.apps.ot.gui.ExecutionSequenceBView;
import org.eso.ohs.phase2.apps.ot.gui.OTViewManager;
import org.eso.ohs.phase2.icdVcs.IcdVcsCfg;

/**
 * Clearing house for low-level configuration information.
 * 
 * <p>
 * @author cmavros 2002/02/11, 1512/P2PP, add log4j
 * $Id: MTIcdVcsCfg.java,v 1.13 2005/02/11 11:00:27 tcanavan Exp $
 */
public class MTIcdVcsCfg extends IcdVcsCfg {

    protected static Logger stdlog_ = Logger.getLogger(MTIcdVcsCfg.class);

    /**
     * Type of object with given id.
     * 
     * @return	Type of object to send to BOB
     */
    public Class getObjType(long id) {
        long retid = Config.getCfg().uniqueToTableId(id);
        return ExecutionSequenceBView.getInstance().getView().getClassForId(
            retid);
    }

    public Class getObjectClassToSend() {
        throw new IllegalArgumentException("Illegal Argument Exception. This method should not be called in OT");
    }

    public boolean hasValidSelection() {
        stdlog_.debug("ot.MyIcdVcsCfg: Has valid selection ");
        return ExecutionSequenceBView.getInstance().isOBSelected();
    }

    public long[] getSelections(int maxNumOBs) throws NullPointerException {
        MaskQueueView maskView = null;
        OTViewManager manager = OTViewManager.getOTViewMgr();
        maskView = (MaskQueueView) manager.getSelectedQueueView();
        if (maskView == null)
            throw new NullPointerException("Plaease select a queue in the Open Queues Tab Pane");
        long[] obIds = maskView.getSelectedExecSequenceOBIds();
        return maskView.getSelectedExecSequenceOBIds();

    }

    public long getSelection(Class objType) {
        OTViewManager manager = OTViewManager.getOTViewMgr();
        return manager.getSelectedQueue().getId();
    }

    public Component getContainer() {
        return null;
    }

    public String getCCSServer() {
        return AppConfig.getAppConfig().getCCSServer();
    }

    public boolean isInVisitorMode() {
        return Config.getCfg().isInVisitorMode();
    }

    public boolean isInEngineeringMode() {
        return Config.getCfg().isInEngineeringMode();
    }

    public boolean isInCloneMode() {
        return Config.getCfg().isInCloneMode();
    }

    public int getUserName() {
        return Config.getCfg().getUserName();
    }

}
