package org.eso.ohs.phase2.apps.masktracker;

// $Id: MaskDetailView.java,v 1.18 2005/03/30 09:56:13 tcanavan Exp $

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

import org.eso.ohs.core.dbb.client.DbbDetailedView;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.Mask;
import org.eso.ohs.persistence.MaskEvent;
import org.eso.ohs.persistence.ObjectManager;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.persistence.dbase.phase2.MaskQueueManager;

/**
 * This class displays the details of the mask in a view
 */

public class MaskDetailView extends DbbDetailedView {

    /** Refernce to a MaskView */
    private MaskView maskView_;

    /** Save Button for saving individual mask records to the database*/
    private JButton saveButton_;

    /** No Longer used */
    //private JButton clearButton_;

    /** Empty Mask Object */
    private Mask emptyMask_ = new Mask();

    //----------------------------------------
    // Constructors
    //----------------------------------------

    /**
     * Display details of a mask in a view
     * @param title Title to be displyed in Frame
     * @param mask_view View foe mask data 
     */

    public MaskDetailView(String title, MaskView mask_view) {
        super(title);
        maskView_ = mask_view;
        maskView_.setObject(emptyMask_);
        buildView();
        setEnabled(false);
        maskView_.setEnabled(false);
    }

    //----------------------------------------
    // Private methods
    //----------------------------------------

    /** 
     * Build a view and add appropriate listenets to buttons
     */

    private void buildView() {

        saveButton_ = new JButton("Save");

        ActionListener save_listener = new ActionListener() {
            public void actionPerformed(ActionEvent event) {
                System.out.println("Save");
                saveMask();
            }
        };

        saveButton_.addActionListener(save_listener);

        /*clearButton_ =  new JButton("Dismiss");
        
        ActionListener clear_listener = new ActionListener() {
        	public void actionPerformed(ActionEvent event){
        		System.out.println("Clear");
        		dismissMask();
        	}
            };
        
        clearButton_.addActionListener(clear_listener);*/

        viewPanel_.add(maskView_);
        addButton(saveButton_);
        addButtonSpace();
        //addButton(clearButton_);
    }

    //----------------------------------------
    // Public methods
    //----------------------------------------

    /**
     * Enable or disable the control buttons depending on the value of
     * the boolean parameter enable. Stop button is enabled when all
     * the buttons have been disabled and viceversa.
     *
     * @param enable Boolean value to enable or disable the control
     *               buttons.
     */
    public void setEnabled(boolean enable) {
        saveButton_.setEnabled(enable);
        //clearButton_.setEnabled(enable);
    }

    /**
     * For carlo
     */

    public void dismissMask() {
        maskView_.setObject(emptyMask_);
        setEnabled(false);
        maskView_.setEnabled(false);
    }

    /**
     * Save mask data back to the database
     */

    public void saveMask() {

        Mask mask_object = (Mask) (maskView_.getObject());

        if (mask_object == null)
            return;

        try {
            ObjectManager.getObjectManager().putBusObj(mask_object);
        } catch (ObjectNotFoundException e) {
            e.printStackTrace();
        } catch (ObjectIOException e) {
            e.printStackTrace();
        }
        MaskQueueManager.fireMaskPropertyChange(
            new MaskEvent("MaskStatus", mask_object.getStatus()));
    }

    /**
     * Get objec from the maskView
     * @return Object
     */

    public Object getObject() {
        return maskView_.getObject();
    }

    /** 
     * Set the object ot be displayed in the details view
     * @param object object to be displayed
     */

    public void setObject(Object object) {
        try {
            Mask newMsk = (Mask) object;
            maskView_.setObject(newMsk);
            setEnabled(true);
            maskView_.setEnabled(true);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
