
package org.eso.ohs.phase2.apps.ot.gui;

import java.awt.BorderLayout;
import java.awt.GridLayout;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


/** The CommentDialog dailog is used to modify the following OB property
 *  observer comments , status , obs grade
 *
 *  @version $Revision: 1.4 $
 *  @author  G.Passera, DMD/ESO, <gpassera@eso.org>
 */
public class CCSSetupView extends JFrame {

    
    private JTextField otEnvNameTF      = new JTextField();
    private JTextField otProcNameTF     = new JTextField();
    private JTextField otStatusTF       = new JTextField();
    private JTextField otTypeTF         = new JTextField();

    private JTextField tsEnvNameTF      = new JTextField();
    private JTextField tsProcNameTF     = new JTextField();
   
    private JTextField spEnvNameTF      = new JTextField();
    private JTextField spProcNameTF     = new JTextField();
   

    /** Default constructor*/ 
    public CCSSetupView() 
    {
    super("CCS Setup");
    
    getContentPane().add(buildLayout());
    pack();
    setVisible(true);
    }


    private JPanel buildLayout()
    {
    JPanel panel = new JPanel(new GridLayout(1,2));
    panel.add(buildOTPanel());
    panel.add(buildVCSRemotePanel());
    return panel;
    }

    /*builds the OTPanel layout*/
    private JPanel buildOTPanel()
    {
    JPanel panel = new JPanel(new BorderLayout());
    JPanel content = new JPanel();
    
    panel.add(new JLabel("OT - LOCAL"),BorderLayout.NORTH);
    panel.add(content,BorderLayout.CENTER);
    
    content.setLayout(new GridLayout(0,2));
    content.add(new JLabel("EnvName"));
    content.add(otEnvNameTF);
    content.add(new JLabel("ProcName"));
    content.add(otProcNameTF);
    content.add(new JLabel("Status"));
    content.add(otStatusTF);
    content.add(new JLabel("Type"));
    content.add(otTypeTF);


    /*
    content.setLayout(new GridBagLayout());
    Container c = (Container) content;
    
    GridBagAdder.add(c,new JLabel("EnvName"),0,0,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,new JLabel("ProcName"),0,1,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,new JLabel("Status"),0,2,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,new JLabel("Type"),0,3,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,otEnvNameTF,1,0,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,otProcNameTF,1,1,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,otStatusTF,1,2,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,otTypeTF,1,3,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
		    
    */
    return panel;
    }


    private JPanel buildVCSRemotePanel()
    {
    JPanel panel    = new JPanel(new BorderLayout());
    JPanel content  = new JPanel(new GridLayout(0,2));

    panel.add(new JLabel("VCS REMOTE"),BorderLayout.NORTH);
    panel.add(content,BorderLayout.CENTER);


    content.add(buildTemplateServerPanel());
    content.add(buildSchedulingPanel());
    return panel;
    }
  

    private JPanel buildTemplateServerPanel()
    {
    JPanel panel = new JPanel(new BorderLayout());
    JPanel content = new JPanel();
    
    panel.add(new JLabel("TEMPLATE SERVER"),BorderLayout.NORTH);
    panel.add(content,BorderLayout.CENTER);
    
    content.setLayout(new GridLayout(0,2));
    content.add(new JLabel("EnvName"));
    content.add(tsEnvNameTF);
    content.add(new JLabel("ProcName"));
    content.add(tsProcNameTF);
   
    /*
    content.setLayout(new GridBagLayout());
    Container c = (Container) content;
    
    GridBagAdder.add(c,new JLabel("EnvName"),0,0,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,new JLabel("ProcName"),0,1,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,tsEnvNameTF,1,0,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,tsProcNameTF,1,1,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    
    GridBagAdder.add(c,new JLabel(""),2,0,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,new JLabel(""),2,1,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    */
    
    return panel;
    }

    JPanel buildSchedulingPanel()
    {
    JPanel panel = new JPanel(new BorderLayout());
    JPanel content = new JPanel();
    
    panel.add(new JLabel("SCHEDULING PARAMETERS SERVER"),BorderLayout.NORTH);
    panel.add(content,BorderLayout.CENTER);

    content.setLayout(new GridLayout(0,2));
    content.add(new JLabel("EnvName"));
    content.add(spEnvNameTF);
    content.add(new JLabel("ProcName"));
    content.add(spProcNameTF);
    
    /*
    content.setLayout(new GridBagLayout());
    Container c = (Container) content;
    
    GridBagAdder.add(c,new JLabel("EnvName"),0,0,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,new JLabel("ProcName"),0,1,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,spEnvNameTF,1,0,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    GridBagAdder.add(c,spProcNameTF,1,1,1,1,0,0,
		     GridBagConstraints.BOTH,GridBagConstraints.CENTER);
    */
   
    return panel;
    }

}










