package org.eso.ohs.phase2.apps.ot.gui;

import java.util.EventObject;

import org.eso.ohs.dfs.Summary;


/**
 * Encapsulates information describing changes to a table of objects,
 * and is used to notify listeners of the change.
 *
 * <p>
 * $Id: SummaryTableEvent.java,v 1.3 2003/07/03 08:49:49 ddorigo Exp $
 * <br>
 * @author Bob Kemp
 */

public class SummaryTableEvent extends EventObject {

    /**
     * Constant to identify an OBJECT_ADDED event     
     */
    public static final int OBJECT_ADDED    = 1;

    /**
     * Constant to identify an OBJECT_CHANGED event     
     */
    public static final int OBJECT_CHANGED   = 3;

    /**
     * Constant to identify an OBJECT_REMOVED event     
     */

    public static final int OBJECT_REMOVED = 5;

   
    private Summary queueSumm_;


    private int eventType_;


    /**
     * Constructor for ObjectTableEvent.
     * 
     * @param type  	type of event: OBJECT_CHANGED, OBJECT_CREATED, etc
     * @param device	medium on which the object resides.
     * @param dir	directory in which the object resides.
     * @param id	id of the object that has changed.
     * @param objType	type of the object that has changed.
     */
    public SummaryTableEvent(Summary summ,int eventType) {
	super(new Long(summ.getId()));
        queueSumm_ = summ;
        eventType_ = eventType;
    }

    /**
     * Retrieves the id of the StorableObject linked with the ObjectTableEvent.
     *
     * @return id of the object affected
     */
    public Summary getQueueSummary() {
	return queueSumm_;
    }  


    public int getEventType() {
	return eventType_;
    }

}

