package org.eso.ohs.phase2.apps.ot.gui;

import java.awt.Component;

import javax.swing.JComboBox;
import javax.swing.JFrame;

import org.eso.ohs.core.gui.widgets.SimpleInputDialog;
import org.eso.ohs.instruments.InstrumentList;


public class TelescopeSelectDialog extends SimpleInputDialog {

    /**   
     * User name entry field
     */
    private JComboBox telescopeList_ 
        = new JComboBox(InstrumentList.getInstance().getTelescopeNames());
   
    /**
     * Create a password dialog
     * @param frm Frame for dialog
     * @param title title of dialog
     */
    public TelescopeSelectDialog(JFrame frm, String title) {
	this(frm, title, null);
    }

    /**
     * Create a telescope dialog
     * so the layout could be different from the default.
     * <br>ChangeLog: cmavros 18-10-01 Call different initialise() method
     * @param frm Frame for dialog
     * @param title title of dialog
     */
    public TelescopeSelectDialog(JFrame frm, String title, String message) {
	super(frm, title);

	initialise(message,
		    new String[] { "Telescope     "},
		    new Component[] {telescopeList_},
                    SimpleInputDialog.EAST,
                    0, 
                    1 
	);	
    }

    protected void requestInitialFocus() {
	telescopeList_.requestFocus();
    }
    

    /**
     * Get the telescope list from the 
     */
    public String getTelescope() {
	return (String)telescopeList_.getSelectedItem();
    }   
    
}
