package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.Box;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;
import org.eso.ohs.core.utilities.MsgManager;
import org.eso.ohs.phase2.orang.OrangScriptException;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

public class AlgorithmChooserPage extends OHSWizardPage {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    JLabel labelTitle = new JLabel();

    JLabel labelPageTitle = new JLabel();

    JLabel labelAlgorithm = new JLabel();

    JComboBox comboBoxAlgorithm = new JComboBox();
    
    JLabel labelInfo = new JLabel();

    private OrangWidgetsData dataWidgets;

    /**
     * Default constructor
     * @param defaultData 
     */
    public AlgorithmChooserPage(OHSWizard controller, OrangWidgetsData defaultData) {
        super(controller);
        dataWidgets = defaultData;
        initializePanel(); 
    }

    /**
     * Adds fill components to empty cells in the first row and first column of
     * the grid. This ensures that the grid spacing will be the same as shown in
     * the designer.
     * 
     * @param cols
     *            an array of column indices in the first row where fill
     *            components should be added.
     * @param rows
     *            an array of row indices in the first column where fill
     *            components should be added.
     */
    void addFillComponents(Container panel, int[] cols, int[] rows) {
        Dimension filler = new Dimension(10, 10);

        boolean filled_cell_11 = false;
        CellConstraints cc = new CellConstraints();
        if (cols.length > 0 && rows.length > 0) {
            if (cols[0] == 1 && rows[0] == 1) {
                /** add a rigid area */
                panel.add(Box.createRigidArea(filler), cc.xy(1, 1));
                filled_cell_11 = true;
            }
        }

        for (int index = 0; index < cols.length; index++) {
            if (cols[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(cols[index], 1));
        }

        for (int index = 0; index < rows.length; index++) {
            if (rows[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(1, rows[index]));
        }

    }


    public JPanel createPanel()
    {
       JPanel jpanel1 = new JPanel();
       FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,LEFT:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:78PX:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:41PX:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE","FILL:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:GROW(1.0),CENTER:DEFAULT:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);

       labelPageTitle.setFont(new Font("sansserif",Font.ITALIC,11));
       labelPageTitle.setName("labelPageTitle");
       labelPageTitle.setText("Step 4: choose ranking algorithm");
       jpanel1.add(labelPageTitle,cc.xywh(2,4,4,1));

       labelAlgorithm.setName("labelAlgorithm");
       labelAlgorithm.setText("Algorithm");
       jpanel1.add(labelAlgorithm,cc.xy(2,7));

       comboBoxAlgorithm.setName("comboBoxAlgorithm");
       jpanel1.add(comboBoxAlgorithm,cc.xy(3,7));

       labelInfo.setName("labelInfo");
       labelInfo.setText("0 Observation blocks loaded");
       jpanel1.add(labelInfo,cc.xy(2,18));

       jpanel1.add(WizardTitlePanel.createPanel(),new CellConstraints(1,1,11,1,CellConstraints.FILL,CellConstraints.DEFAULT));
       addFillComponents(jpanel1,new int[]{ 1,2,3,4,5,6,7,8,9,10,11 },new int[]{ 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18 });
       return jpanel1;
    }


    /**
     * Initializer
     */
    protected void initializePanel() {
        setLayout(new BorderLayout());
        add(createPanel(), BorderLayout.CENTER);
        listenTo(comboBoxAlgorithm);
        reloadScriptList();
     
    }

    /**
     *  void removes the items and reload them
     */
    public  void reloadScriptList() {
        String[] algoritmList = new String[0];
        try {
            algoritmList = dataWidgets.getAlgorithmList();
        } catch (OrangScriptException e) {
           MsgManager.errDialog(e);            
        }
        if (comboBoxAlgorithm.getItemCount() > 0){
        comboBoxAlgorithm.removeAllItems();
        }
        for (int i = 0; i < algoritmList.length; i++) {
            comboBoxAlgorithm.addItem(algoritmList[i]);
        }
    }

    protected boolean isReady() { 
        return true;
    }
    
    public void setInfo(String info) {
    	this.labelInfo.setText(info);
    }

}
