package org.eso.ohs.phase2.apps.ot.wizard;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.text.ParseException;

import javax.swing.AbstractAction;
import javax.swing.Box;
import javax.swing.DefaultButtonModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import org.eso.ohs.core.gui.widgets.OHSButtonGroup;
import org.eso.ohs.core.gui.widgets.OHSWizard;
import org.eso.ohs.core.gui.widgets.OHSWizardPage;
import org.eso.ohs.core.utilities.Convert;

import com.jeta.forms.components.image.ImageComponent;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

public class ObSelectorView extends OHSWizardPage {

    private static final long serialVersionUID = 1L;

    JPanel jPanel = new JPanel();

    JLabel labelPageTitle = new JLabel();

    JRadioButton radioButtonQueues = new JRadioButton();

    OHSButtonGroup obSelectionGroup = new OHSButtonGroup("obSelectionGroup");

    JList listBoxQueues = new JList();

    JLabel labelTitle = new JLabel();

    JLabel startTimeLabel = new JLabel();

    JLabel durationLabel = new JLabel();

    JLabel stepIntervalLabel = new JLabel();

    JRadioButton radioButtonTelescope = new JRadioButton();

    JRadioButton radioButtonInstrument = new JRadioButton();

    JComboBox comboBoxTelescope = new JComboBox();

    JComboBox comboBoxInstrument = new JComboBox();

    JButton nowButton = new JButton();

    JTextField startTimeTextField = new JTextField();

    JComboBox durationComboBox = new JComboBox();

    JComboBox stepComboBox = new JComboBox();

    ImageComponent orange = new ImageComponent();

    OrangWidgetsData dataWidgets = null;

    /**
     * Default constructor
     */
    public ObSelectorView(OHSWizard controller, OrangWidgetsData data) {
        super(controller);
        dataWidgets = data;
        initializePanel();
    }

    /**
     * Adds fill components to empty cells in the first row and first column of
     * the grid. This ensures that the grid spacing will be the same as shown in
     * the designer.
     * 
     * @param cols
     *            an array of column indices in the first row where fill
     *            components should be added.
     * @param rows
     *            an array of row indices in the first column where fill
     *            components should be added.
     */
    void addFillComponents(Container panel, int[] cols, int[] rows) {
        Dimension filler = new Dimension(10, 10);

        boolean filled_cell_11 = false;
        CellConstraints cc = new CellConstraints();
        if (cols.length > 0 && rows.length > 0) {
            if (cols[0] == 1 && rows[0] == 1) {
                /** add a rigid area */
                panel.add(Box.createRigidArea(filler), cc.xy(1, 1));
                filled_cell_11 = true;
            }
        }

        for (int index = 0; index < cols.length; index++) {
            if (cols[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(cols[index], 1));
        }

        for (int index = 0; index < rows.length; index++) {
            if (rows[index] == 1 && filled_cell_11) {
                continue;
            }
            panel.add(Box.createRigidArea(filler), cc.xy(1, rows[index]));
        }

    }

    public JPanel createjPanel() {
        jPanel.setName("jPanel");
        FormLayout formlayout1 = new FormLayout(
                "FILL:DEFAULT:NONE,LEFT:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(0.5),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE",
                "CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
        CellConstraints cc = new CellConstraints();
        jPanel.setLayout(formlayout1);

        labelPageTitle.setFont(new Font("sansserif", Font.ITALIC, 11));
        labelPageTitle.setName("labelPageTitle");
        labelPageTitle.setText("Step 1: select the OBs you want to consider");
        jPanel.add(labelPageTitle, cc.xywh(2, 3, 7, 1));

        radioButtonQueues.setActionCommand("Queues");
        radioButtonQueues.setName("radioButtonQueues");
        radioButtonQueues.setText("Queues");
        radioButtonQueues.setToolTipText("Select one ore more queues");
        obSelectionGroup.add(radioButtonQueues);
        jPanel.add(radioButtonQueues, new CellConstraints(2, 8, 2, 1,
                CellConstraints.DEFAULT, CellConstraints.TOP));

        startTimeLabel.setName("startTimeLabel");
        startTimeLabel.setText("Start Time:");
        startTimeLabel.setToolTipText("UT time.");
        jPanel.add(startTimeLabel, cc.xywh(2, 12, 2, 1));

        durationLabel.setName("durationLabel");
        durationLabel.setText("Duration(hours):");
        jPanel.add(durationLabel, cc.xywh(2, 14, 2, 1));

        stepIntervalLabel.setName("stepIntervalLabel");
        stepIntervalLabel.setText("Step  interval(minutes):");
        jPanel.add(stepIntervalLabel, cc.xywh(2, 16, 2, 1));

        radioButtonTelescope.setActionCommand("Telescope today queues");
        radioButtonTelescope.setName("radioButtonTelescope");
        radioButtonTelescope.setText("Telescope today queues");
        radioButtonTelescope
                .setToolTipText("Select all today queues from a telescope");
        obSelectionGroup.add(radioButtonTelescope);
        jPanel.add(radioButtonTelescope, cc.xy(2, 6));

        radioButtonInstrument.setActionCommand("Instrument today queues");
        radioButtonInstrument.setName("radioButtonInstrument");
        radioButtonInstrument.setText("Instrument today queues");
        radioButtonInstrument
                .setToolTipText("Select all today queues from an instrument");
        obSelectionGroup.add(radioButtonInstrument);
        jPanel.add(radioButtonInstrument, cc.xy(2, 7));

        jPanel.add(WizardTitlePanel.createPanel(), cc.xywh(1, 1, 12, 1));
        comboBoxTelescope.setName("comboBoxTelescope");
        jPanel.add(comboBoxTelescope, cc.xy(4, 6));

        comboBoxInstrument.setName("comboBoxInstrument");
        jPanel.add(comboBoxInstrument, cc.xy(4, 7));

        listBoxQueues.setName("listBoxQueues");
        JScrollPane jscrollpane1 = new JScrollPane();
        jscrollpane1.setViewportView(listBoxQueues);
        jscrollpane1
                .setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        jscrollpane1
                .setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        jPanel.add(jscrollpane1, cc.xy(4, 8));

        startTimeTextField.setName("startTimeTextField");
        jPanel.add(startTimeTextField, cc.xy(4, 12));

        durationComboBox.setName("durationComboBox");
        jPanel.add(durationComboBox, cc.xywh(4, 14, 8, 1));

        stepComboBox.setName("stepComboBox");
        jPanel.add(stepComboBox, cc.xywh(4, 16, 8, 1));

        nowButton.setActionCommand("Now");
        nowButton.setName("nowButton");
        nowButton.setText("Now");
        jPanel.add(nowButton, cc.xywh(6, 12, 6, 1));

        addFillComponents(jPanel, new int[]
        { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 }, new int[]
        { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 });
        return jPanel;
    }

    /**
     * Initializer
     */
    protected void initializePanel() {
        setLayout(new BorderLayout());
        add(createjPanel(), BorderLayout.CENTER);

        listenTo(listBoxQueues);
        listenTo(comboBoxInstrument);
        listenTo(comboBoxTelescope);
        listenTo(radioButtonQueues);
        listenTo(radioButtonTelescope);
        listenTo(radioButtonInstrument);
        listenTo(stepComboBox);
        listenTo(startTimeTextField);
        listenTo(durationComboBox);
       
        radioButtonQueues.setSelected(true);
        radioButtonQueues.doClick();
        // sets the start time to the current time. The name of the action is 
        // the one displayed
        nowButton.setAction(new AbstractAction("Now") {
            private static final long serialVersionUID = 1L;

            public void actionPerformed(ActionEvent e) {
                startTimeTextField.setText(dataWidgets.getStartISODate());
            }
        });

        // the completion happens when the pointer exits from the widget
        startTimeTextField.addFocusListener(new FocusListener() {

            public void focusGained(FocusEvent e) {
            }

            public void focusLost(FocusEvent e) {
                String currentISODate = startTimeTextField.getText();
                try {
                    String newDate = Convert
                            .completeISODateString(currentISODate);
                    startTimeTextField.setText(newDate);
                } catch (ParseException e1) {
                    // don't do anything.
                }

            }

        });
        
        // retrieve the default data from the model.
        String[] queueList = dataWidgets.getQueues();
        listBoxQueues.setListData(queueList);
        addItems(comboBoxTelescope, dataWidgets.getTelescopes());
        addItems(comboBoxInstrument, dataWidgets.getInstruments());
        addItems(stepComboBox, dataWidgets.getStepRangeList());
        addItems(durationComboBox, dataWidgets.getDurationRangeList());
        startTimeTextField.setText(dataWidgets.getStartISODate());

    }

  

    protected boolean isReady() {
        boolean result = false;

        DefaultButtonModel selectedButton = (DefaultButtonModel) obSelectionGroup
                .getSelection();

         if (isISODate(startTimeTextField.getText()) && selectedButton != null) {
             result = true;
             if (radioButtonQueues.isSelected()&&
                     listBoxQueues.getSelectedIndex()< 0) {               
                     result = false;
                 }          
        }
        return result;
    }

    private boolean isISODate(String text) {
        boolean result = true;
        try {
            Convert.ISOdateToLong(text);
        } catch (ParseException e) {
            result = false;
        }
        return result;
    }

}
