package org.eso.ohs.phase2.apps.p2pp;

import javax.swing.text.Document;
import javax.swing.text.PlainDocument;

import org.eso.ohs.core.gui.models.BoNameModel;
import org.eso.ohs.core.gui.models.DeclinationModel;
import org.eso.ohs.core.gui.models.EpochModel;
import org.eso.ohs.core.gui.models.EquinoxModel;
import org.eso.ohs.core.gui.models.LimitedCharsModel;
import org.eso.ohs.core.gui.models.RightAscensionModel;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.dfs.ConstraintSet;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.dfs.ObservationDescription;
import org.eso.ohs.dfs.Target;

public class DocumentFactory {

    public static Document getDocument(Class objType, String fieldName) {
	Document doc = null;

	if (fieldName.equals("Name")) {
	    doc = new BoNameModel();
	}
	else if (objType.equals(Target.class)) {
	    if (fieldName.equals("ProperDeclination")
				|| fieldName.equals("Declination")) {
		doc = new DeclinationModel();
	    }
	    else if (fieldName.equals("PropRA")
				|| fieldName.equals("RA")) {
		doc = new RightAscensionModel();
	    }
	    else if (fieldName.equals("Equinox")) {
		doc = new EquinoxModel();
	    }
	    else if (fieldName.equals("Epoch")) {
		doc = new EpochModel();
	    }
	    else if (fieldName.equals("UserComments")) {
		doc = new LimitedCharsModel();
	    }
	}
	else if (objType.equals(ObservationBlock.class)) {

	    if (fieldName.equals("UserComments")
			|| fieldName.equals("CalibrationRequirements")) {
		doc = new LimitedCharsModel();
	    }

	}
	else if (objType.equals(CalibrationBlock.class)
			|| objType.equals(ObservationDescription.class)) {

	    if (fieldName.equals("UserComments")) {
		doc = new LimitedCharsModel();
	    }

	}
	else if (objType.equals(ConstraintSet.class)) {

	    if (fieldName.equals("Description")) {
		doc = new LimitedCharsModel();
	    }

	}

	return doc != null ? doc : new PlainDocument();
    }

}

