package org.eso.ohs.phase2.apps.p2pp.views;

import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import org.eso.ohs.instruments.Instrument;

/**
 * This renders a cell in the template lists in ODView
 * and OBView.
 * <p>
 * $Id: TemplateListCellRenderer.java,v 1.3 2003/07/03 08:49:49 ddorigo Exp $
 * @author Tim Canavan
 */



public class TemplateListCellRenderer extends DefaultListCellRenderer implements ListCellRenderer {

    /**
     * Instrument associated with the list of templates
     */


    Instrument inst_;

    /**
     * Create TemplateListCellRenderer
     * @param inst reference to instrument associated with template list
     * 
     */

    public TemplateListCellRenderer(Instrument inst) {
        super();
        inst_ = inst;
    }


    /**
     * Return the component to be displayed in the list
     * with the appropriate tooltip text set
     * @param list JList to be displayed
     * @param value value to be displayed at a give n cell
     * @param index index for a given value 
     * @param isSelected whether an item in the list is selected or not
     * @param cellHasFocus whether a cell has focus or not
     */


    public Component getListCellRendererComponent( JList list,
                Object value, int index, boolean isSelected, boolean
cellHasFocus) {

        Component c = super.getListCellRendererComponent(list,value,index,isSelected,cellHasFocus);
        if(index >=0) {             
	    String desc = (String)inst_.getTemplateDesc((String)value);
            String tooltp=null;
            if(desc == null || desc.length() == 0)
                tooltp = "No Description for : " +  value;               
            else
	        tooltp = value + "  " + desc;	   
            ((JComponent)c).setToolTipText(tooltp);        
        }               
        return c;
    }
}



