package org.eso.ohs.phase2.orang;

import java.math.BigDecimal;
import java.util.Date;
import java.util.Hashtable;

import org.eso.ohs.core.utilities.DateContainer;
import org.eso.ohs.scripting.TimeIntervalSetAPI;


/**
 * This interfaces to the ObTargetConstraintInfo objects. 
 * Interface currently exposed to the scripting env
 * @author Paulo Nunes
 */


public interface ObScheduleInfoAPI {
		
	
	/*
	 * Get the properties from OBDataContainer
	 */
    public long getCreationDate();    
    public int getRepeats();   
    public int getRunId();    
    public String getStatus();    
    public String getType() ;    
    public int getUserId();    
    public String getUserPriority();        
	public String getAirmass();	
	public String getDec();	 // in degrees
	public float getDiffDec();	
	public float getDiffRA();	
	public String getFractionalLunarIllumination();	
	public int getMoonAngularDistance();	
	public float getPropDec();	
	public float getPropRA();	
	
	public String getRa(); // in degrees	
	
	public String getSeeing();	
	public String getSkyTransparency();	
	public float getStrehlRatio();	
	public int getExecutionTime();
		
	/*
	 * Get the properties from SchedRun
	 */ 		  	
	public int getPeriod();	
	public String getProgId();		
	public String getObsMode();	
	public String getTelescope();	
	public long getFromDate();	
	public String getFromDateString();	
	public Date getFromDateObj();	
	public Date getToDateObj();	
	public DateContainer getFromDateFields();	
	public DateContainer getToDateFields();	
	public long getToDate();	
	public String getToDateString();	
	public float getNight();	
	public String getPiCoi();	
	public String getAffil();	
	public String getInstrument();	
	public String getRemarks();	
	public String getTitle();	
	public String getObserver();	
	public String getObserverEmail();	
	public String getNightAssistant();	
	public String getSupportAssistant();	
	public String getMonth();	
	public String getMoon();	
	public int getSchedSeeing();	
	public int getRank();	
	public String getNightFract();	
	public String getRankClass();	
	public String getLastMod();	
	public int getPublished();	
	public BigDecimal getIpversion();	
	public boolean isPublished();	
	public String getSeeingString();
	
    // run properties method

    public boolean getChilean();    
    public boolean getPreImaging(); 
    public boolean getCarryOver();   
    public boolean getLarge(); 
    public boolean getTimeCritical();
    public boolean isRunStarted();
    /**
     * Get the timing intervals for this OB
     * @return TimingIntervalSetAPI object for this OB
     */
    public TimeIntervalSetAPI getTimeIntervals();
    
    /**
     * Get the sidereal timing intervals for this OB
     * @return TimingIntervalSetAPI object for this OB
     */
    public TimeIntervalSetAPI getSTTimeIntervals();
    
    
    public void setRankScore(String rank);	
    public String getRankScore();        
	public Hashtable getKWValues();	
	public boolean getSecondHalfTimeInterval();	
	public OBScheduleInfo getObSchedInfo();
	
	/*
	 * Calculates the Local sidereal time, for the starting date/time
	 * of the OB visibility computation
	 */
	public double getLST();
	
	
	
}


