package org.eso.ohs.phase2.visibility;

/**
 * A PCFPlotterFilter extension for plotting fractional lunar illum.
 * The class accepts a constraint value, and uses this to return a value of 
 * either 1 (the FLI is less than or equal to constraint) or 0 (the FLI 
 * is greater than the constraint).
 *
 * @author Nick Kornweibel for ESO.
 */

public class FLIFilter extends PCFPlotterFilter {

    private double constraint_;

    public FLIFilter(double constraint) {
        setConstraint(constraint);
    }

    public double getContraint() {
        return constraint_;
    }

    public void setConstraint(double constraint) {
        constraint_ = constraint;
    }

    public double input(PCFInterval interval)
            throws PCFPlotterFilter.ValueRejectedException {
        double rc;
        if (interval.getValue() <= constraint_) {
            rc = 1.0;
        } else {
            rc = 0.0;

        }
        return rc;
    }
}
