package org.eso.ohs.phase2.visibility;

/**
 * A PCFPlotterFilter extension for plotting sun angle. The class accepts
 * a constraint value, and uses this to return a value of either 1 (the
 * sun is at an equal or greater angle than the constraint) or 0 (the sun
 * angle is less than the constraint).
 *
 * @author Nick Kornweibel for ESO.
 */

public class SunAngleFilter extends PCFPlotterFilter {

    private double constraint_;

    public SunAngleFilter(double constraint) {
        setConstraint(constraint);
    }

    public double getContraint() {
        return constraint_;
    }

    public void setConstraint(double constraint) {
        constraint_ = constraint;
    }

    public double input(PCFInterval interval)
            throws PCFPlotterFilter.ValueRejectedException {
        double rc;
        if (interval.getValue() > constraint_) {
            rc = 0.0;
        } else {
            rc = 1.0;

        }
        return rc;
    }
}
