package org.eso.ohs.phase2.visiplot;

import java.awt.BorderLayout;
import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JColorChooser;
import javax.swing.JFrame;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.eso.ohs.core.gui.widgets.SimpleInputDialog;

/**
 * Open a JColorChooser and set the new colors for the chart
 * @author gdonino
 *
 */

public class LabelsColorEditor extends SimpleInputDialog
                              implements ChangeListener {

    protected JColorChooser tcc;
    private ChartColorItem item_;

    public LabelsColorEditor(ChartColorItem item, JFrame parentFrame, boolean modal, String title) {
    	 super(parentFrame, title, "", null, new Component[]{});
    

    	setTitle(title);
    	item_ = item;    
        tcc = new JColorChooser(item_.getLabelsColor());
        tcc.getSelectionModel().addChangeListener(this);
        tcc.setBorder(BorderFactory.createTitledBorder(""));
 
        getContentPane().add(tcc, BorderLayout.PAGE_START);
    }
    
    public void stateChanged(ChangeEvent e) {
        item_.setLabelsColor(tcc.getColor());
    }

}
